searchNodes=[{"doc":"Lapin, an Elixir RabbitMQ client Comprehensive documentation is available here .","ref":"Lapin.html","title":"Lapin","type":"module"},{"doc":"Lapin configuration","ref":"Lapin.html#t:config/0","title":"Lapin.config/0","type":"type"},{"doc":"RabbitMQ connection handler This module handles the RabbitMQ connection. It also provides a behaviour for worker module implementation. The worker module should use the Lapin.Connection behaviour and implement the callbacks it needs. When using the Lapin.Connection behaviour a publish/4 function is injected in the worker module as a shortcut to the Lapin.Connection.publish/5 function which removes the need for passing in the connection and is publicly callable to publish messages on the connection configured for the implementing module.","ref":"Lapin.Connection.html","title":"Lapin.Connection","type":"behaviour"},{"doc":"Closes the connection","ref":"Lapin.Connection.html#close/1","title":"Lapin.Connection.close/1","type":"function"},{"doc":"Called when receiving a basic.cancel from the broker.","ref":"Lapin.Connection.html#c:handle_cancel/1","title":"Lapin.Connection.handle_cancel/1","type":"callback"},{"doc":"Called when receiving a basic.cancel_ok from the broker.","ref":"Lapin.Connection.html#c:handle_cancel_ok/1","title":"Lapin.Connection.handle_cancel_ok/1","type":"callback"},{"doc":"Called when receiving a basic.consume_ok from the broker. This signals successul registration as a consumer.","ref":"Lapin.Connection.html#c:handle_consume_ok/1","title":"Lapin.Connection.handle_consume_ok/1","type":"callback"},{"doc":"Called when receiving a basic.deliver from the broker. Return values from this callback determine message acknowledgement: :ok : Message was processed by the consumer and should be removed from queue {:reject, reason} : Message was not processed and should be rejected Any other return value requeues the message to prevent data loss. A crash in the callback code will however reject the message to prevent loops if the message was already delivered before. The reason term can be used by the application to signal the reason of rejection and is logged in debug.","ref":"Lapin.Connection.html#c:handle_deliver/2","title":"Lapin.Connection.handle_deliver/2","type":"callback"},{"doc":"Called when completing a basic.publish with the broker. Message transmission to the broker is successful when this callback is called.","ref":"Lapin.Connection.html#c:handle_publish/2","title":"Lapin.Connection.handle_publish/2","type":"callback"},{"doc":"Called when receiving a basic.return from the broker. This signals an undeliverable returned message from the broker.","ref":"Lapin.Connection.html#c:handle_return/2","title":"Lapin.Connection.handle_return/2","type":"callback"},{"doc":"Called before handle_deliver/2 to get the payload type. Should return a data type instance to decode the payload into. A Lapin.Message.Payload implementation must be provided for this type. The default implementation leaves the payload unaltered.","ref":"Lapin.Connection.html#c:payload_for/2","title":"Lapin.Connection.payload_for/2","type":"callback"},{"doc":"Publishes a message to the specified exchange with the given routing_key","ref":"Lapin.Connection.html#publish/5","title":"Lapin.Connection.publish/5","type":"function"},{"doc":"Starts a Lapin.Connection with the specified configuration","ref":"Lapin.Connection.html#start_link/2","title":"Lapin.Connection.start_link/2","type":"function"},{"doc":"Connection configuration The following keys are supported: module: module using the Lapin.Connection behaviour uri: AMQP URI (String.t | URI.t) host: broker hostname (string | charlist), default: 'localhost' port: broker port (string | integer), default: 5672 virtual_host: broker vhost (string), default: &quot;/&quot; username: username (string) password: password (string) auth_mechanisms: broker auth_mechanisms ([:amqplain | :external | :plain]), default: amqp_client default ssl_options: ssl options ([:ssl:ssl_option]), default: none producers: producers to configure ([Producer.config]), default: [] consumers: consumers to configure ([Consumer.config]), default: []","ref":"Lapin.Connection.html#t:config/0","title":"Lapin.Connection.config/0","type":"type"},{"doc":"Callback result","ref":"Lapin.Connection.html#t:on_callback/0","title":"Lapin.Connection.on_callback/0","type":"type"},{"doc":"handle_deliver/2 callback result","ref":"Lapin.Connection.html#t:on_deliver/0","title":"Lapin.Connection.on_deliver/0","type":"type"},{"doc":"Reason for message rejection","ref":"Lapin.Connection.html#t:reason/0","title":"Lapin.Connection.reason/0","type":"type"},{"doc":"Connection","ref":"Lapin.Connection.html#t:t/0","title":"Lapin.Connection.t/0","type":"type"},{"doc":"Lapin Connections Supervisor","ref":"Lapin.Connection.Supervisor.html","title":"Lapin.Connection.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Lapin.Connection.Supervisor.html#child_spec/1","title":"Lapin.Connection.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"Lapin.Connection.Supervisor.html#init/1","title":"Lapin.Connection.Supervisor.init/1","type":"function"},{"doc":"","ref":"Lapin.Connection.Supervisor.html#start_link/1","title":"Lapin.Connection.Supervisor.start_link/1","type":"function"},{"doc":"Extensible behaviour to define consumer configuration. Lapin provides a number of submodules which implement the patterns found in the RabbitMQ Tutorials . defmodule ExampleApp.SomeConsumer do use Lapin.Consumer [ ... callbacks implementation ... ] end","ref":"Lapin.Consumer.html","title":"Lapin.Consumer","type":"behaviour"},{"doc":"Consumer acknowledgements enabled","ref":"Lapin.Consumer.html#c:ack/1","title":"Lapin.Consumer.ack/1","type":"callback"},{"doc":"ACK message consumption","ref":"Lapin.Consumer.html#ack_message/2","title":"Lapin.Consumer.ack_message/2","type":"function"},{"doc":"Creates a consumer from configuration","ref":"Lapin.Consumer.html#create/2","title":"Lapin.Consumer.create/2","type":"function"},{"doc":"Find consumer by consumer_tag","ref":"Lapin.Consumer.html#get/2","title":"Lapin.Consumer.get/2","type":"function"},{"doc":"Consumer message prefetch count","ref":"Lapin.Consumer.html#c:prefetch_count/1","title":"Lapin.Consumer.prefetch_count/1","type":"callback"},{"doc":"Queue to consume from","ref":"Lapin.Consumer.html#c:queue/1","title":"Lapin.Consumer.queue/1","type":"callback"},{"doc":"Reject message","ref":"Lapin.Consumer.html#reject_message/3","title":"Lapin.Consumer.reject_message/3","type":"function"},{"doc":"Consumer configuration The following keys are supported: pattern: producer pattern (module using the Lapin.Producer behaviour) If using the Lapin.Consumer.Config default implementation, the following keys are also supported: queue: queue to consume from, ( String.t() , required ) ack: producer ack ( boolean() , default: false* prefetch_count: consumer prefetch count ( integer() , default: 1 )","ref":"Lapin.Consumer.html#t:config/0","title":"Lapin.Consumer.config/0","type":"type"},{"doc":"Consumer Tag","ref":"Lapin.Consumer.html#t:consumer_tag/0","title":"Lapin.Consumer.consumer_tag/0","type":"type"},{"doc":"Consumer Prefetch","ref":"Lapin.Consumer.html#t:prefetch_count/0","title":"Lapin.Consumer.prefetch_count/0","type":"type"},{"doc":"Lapin Consumer Behaviour","ref":"Lapin.Consumer.html#t:t/0","title":"Lapin.Consumer.t/0","type":"type"},{"doc":"Lapin Consumer default pattern, reads settings from configuration","ref":"Lapin.Consumer.Config.html","title":"Lapin.Consumer.Config","type":"module"},{"doc":"Callback implementation for Lapin.Consumer.ack/1 .","ref":"Lapin.Consumer.Config.html#ack/1","title":"Lapin.Consumer.Config.ack/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.prefetch_count/1 .","ref":"Lapin.Consumer.Config.html#prefetch_count/1","title":"Lapin.Consumer.Config.prefetch_count/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.queue/1 .","ref":"Lapin.Consumer.Config.html#queue/1","title":"Lapin.Consumer.Config.queue/1","type":"function"},{"doc":"Lapin.Consumer implementation for the Publish/Subscribe RabbitMQ pattern.","ref":"Lapin.Consumer.PubSub.html","title":"Lapin.Consumer.PubSub","type":"module"},{"doc":"Callback implementation for Lapin.Consumer.ack/1 .","ref":"Lapin.Consumer.PubSub.html#ack/1","title":"Lapin.Consumer.PubSub.ack/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.prefetch_count/1 .","ref":"Lapin.Consumer.PubSub.html#prefetch_count/1","title":"Lapin.Consumer.PubSub.prefetch_count/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.queue/1 .","ref":"Lapin.Consumer.PubSub.html#queue/1","title":"Lapin.Consumer.PubSub.queue/1","type":"function"},{"doc":"Lapin.Consumer implementation for the Routing RabbitMQ pattern.","ref":"Lapin.Consumer.Routing.html","title":"Lapin.Consumer.Routing","type":"module"},{"doc":"Callback implementation for Lapin.Consumer.ack/1 .","ref":"Lapin.Consumer.Routing.html#ack/1","title":"Lapin.Consumer.Routing.ack/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.prefetch_count/1 .","ref":"Lapin.Consumer.Routing.html#prefetch_count/1","title":"Lapin.Consumer.Routing.prefetch_count/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.queue/1 .","ref":"Lapin.Consumer.Routing.html#queue/1","title":"Lapin.Consumer.Routing.queue/1","type":"function"},{"doc":"Lapin.Consumer implementation for the Topics RabbitMQ pattern.","ref":"Lapin.Consumer.Topic.html","title":"Lapin.Consumer.Topic","type":"module"},{"doc":"Callback implementation for Lapin.Consumer.ack/1 .","ref":"Lapin.Consumer.Topic.html#ack/1","title":"Lapin.Consumer.Topic.ack/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.prefetch_count/1 .","ref":"Lapin.Consumer.Topic.html#prefetch_count/1","title":"Lapin.Consumer.Topic.prefetch_count/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.queue/1 .","ref":"Lapin.Consumer.Topic.html#queue/1","title":"Lapin.Consumer.Topic.queue/1","type":"function"},{"doc":"Lapin.Consumer implementation for the Work Queues RabbitMQ pattern.","ref":"Lapin.Consumer.WorkQueue.html","title":"Lapin.Consumer.WorkQueue","type":"module"},{"doc":"Callback implementation for Lapin.Consumer.ack/1 .","ref":"Lapin.Consumer.WorkQueue.html#ack/1","title":"Lapin.Consumer.WorkQueue.ack/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.prefetch_count/1 .","ref":"Lapin.Consumer.WorkQueue.html#prefetch_count/1","title":"Lapin.Consumer.WorkQueue.prefetch_count/1","type":"function"},{"doc":"Callback implementation for Lapin.Consumer.queue/1 .","ref":"Lapin.Consumer.WorkQueue.html#queue/1","title":"Lapin.Consumer.WorkQueue.queue/1","type":"function"},{"doc":"Lapin Exchange","ref":"Lapin.Exchange.html","title":"Lapin.Exchange","type":"module"},{"doc":"","ref":"Lapin.Exchange.html#bind/2","title":"Lapin.Exchange.bind/2","type":"function"},{"doc":"","ref":"Lapin.Exchange.html#declare/2","title":"Lapin.Exchange.declare/2","type":"function"},{"doc":"","ref":"Lapin.Exchange.html#new/2","title":"Lapin.Exchange.new/2","type":"function"},{"doc":"","ref":"Lapin.Exchange.html#t:name/0","title":"Lapin.Exchange.name/0","type":"type"},{"doc":"","ref":"Lapin.Exchange.html#t:routing_key/0","title":"Lapin.Exchange.routing_key/0","type":"type"},{"doc":"Exchange","ref":"Lapin.Exchange.html#t:t/0","title":"Lapin.Exchange.t/0","type":"type"},{"doc":"","ref":"Lapin.Exchange.html#t:type/0","title":"Lapin.Exchange.type/0","type":"type"},{"doc":"Lapin Message struct","ref":"Lapin.Message.html","title":"Lapin.Message","type":"module"},{"doc":"Message metadata","ref":"Lapin.Message.html#t:meta/0","title":"Lapin.Message.meta/0","type":"type"},{"doc":"Message payload","ref":"Lapin.Message.html#t:payload/0","title":"Lapin.Message.payload/0","type":"type"},{"doc":"Lapin Message container","ref":"Lapin.Message.html#t:t/0","title":"Lapin.Message.t/0","type":"type"},{"doc":"You can use this protocol to implement a custom message payload transformation. For example you could implement a JSON message with a predefined structure by first implementing a struct for your payload: defmodule Example.Payload do defstruct [ a : &quot;a&quot; , b : &quot;b&quot; , c : nil ] end and then providing an implementation of Lapin.Message.Payload for it: defimpl Lapin.Message.Payload , for : Example.Payload do def content_type ( _payload ) , do : &quot;application/json&quot; def encode ( payload ) , do : Poison . encode ( payload ) def decode_into ( payload , data ) , do : Poison . decode ( data , as : payload ) end Please note you will need to add the poison library as a dependency on in your project mix.exs for this to work. Lapin will automatically encode and set the content-type property on publish. To decode messages before consuming, implement the payload_for/2 callback of Lapin.Connection and return an instance of the payload to decode into. defmodule Example.Connection do def payload_for ( _channel , _message ) , do : % Example.Payload { } end The default implementation simply returns the unaltered binary data and sets the message content-type property to nil .","ref":"Lapin.Message.Payload.html","title":"Lapin.Message.Payload","type":"protocol"},{"doc":"Returns the message content-type","ref":"Lapin.Message.Payload.html#content_type/1","title":"Lapin.Message.Payload.content_type/1","type":"function"},{"doc":"Returns the payload with message data decoded","ref":"Lapin.Message.Payload.html#decode_into/2","title":"Lapin.Message.Payload.decode_into/2","type":"function"},{"doc":"Returns the encoded payload body","ref":"Lapin.Message.Payload.html#encode/1","title":"Lapin.Message.Payload.encode/1","type":"function"},{"doc":"MIME content-type as defined by RFC 2045","ref":"Lapin.Message.Payload.html#t:content_type/0","title":"Lapin.Message.Payload.content_type/0","type":"type"},{"doc":"Decode function return values","ref":"Lapin.Message.Payload.html#t:on_decode/0","title":"Lapin.Message.Payload.on_decode/0","type":"type"},{"doc":"Encode function return values","ref":"Lapin.Message.Payload.html#t:on_encode/0","title":"Lapin.Message.Payload.on_encode/0","type":"type"},{"doc":"Data type implementing the Lapin.Message.Payload protocol","ref":"Lapin.Message.Payload.html#t:t/0","title":"Lapin.Message.Payload.t/0","type":"type"},{"doc":"Extensible behaviour to define producer configuration. Lapin provides a number of submodules which implement the patterns found in the RabbitMQ Tutorials . defmodule ExampleApp.SomePatter do use Lapin.Producer [ ... callbacks implementation ... ] end","ref":"Lapin.Producer.html","title":"Lapin.Producer","type":"behaviour"},{"doc":"Wait for publish confirmation","ref":"Lapin.Producer.html#confirm/1","title":"Lapin.Producer.confirm/1","type":"function"},{"doc":"Request publisher confirms (RabbitMQ only)","ref":"Lapin.Producer.html#c:confirm/1","title":"Lapin.Producer.confirm/1","type":"callback"},{"doc":"Creates a producer from configuration","ref":"Lapin.Producer.html#create/2","title":"Lapin.Producer.create/2","type":"function"},{"doc":"Declare exchange","ref":"Lapin.Producer.html#c:exchange/1","title":"Lapin.Producer.exchange/1","type":"callback"},{"doc":"Find consumer by consumer_tag","ref":"Lapin.Producer.html#get/2","title":"Lapin.Producer.get/2","type":"function"},{"doc":"Request message mandatory routing when publishing","ref":"Lapin.Producer.html#c:mandatory/1","title":"Lapin.Producer.mandatory/1","type":"callback"},{"doc":"Request message persistence when publishing","ref":"Lapin.Producer.html#c:persistent/1","title":"Lapin.Producer.persistent/1","type":"callback"},{"doc":"Publish message","ref":"Lapin.Producer.html#publish/5","title":"Lapin.Producer.publish/5","type":"function"},{"doc":"Producer configuration The following keys are supported: pattern: producer pattern (module using the Lapin.Producer behaviour) If using the Lapin.Producer.Config default implementation, the following keys are also supported: exchange: exchange used for publish ( String.t , required ) confirm: expect RabbitMQ publish confirms ( boolean() , default: false ) mandatory: messages published as mandatory by default ( boolean() , default: false ) persistent: messages published as persistent by default ( boolean() , default: false )","ref":"Lapin.Producer.html#t:config/0","title":"Lapin.Producer.config/0","type":"type"},{"doc":"Lapin Producer","ref":"Lapin.Producer.html#t:t/0","title":"Lapin.Producer.t/0","type":"type"},{"doc":"Lapin Producer default pattern, reads settings from configuration","ref":"Lapin.Producer.Config.html","title":"Lapin.Producer.Config","type":"module"},{"doc":"Callback implementation for Lapin.Producer.confirm/1 .","ref":"Lapin.Producer.Config.html#confirm/1","title":"Lapin.Producer.Config.confirm/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.exchange/1 .","ref":"Lapin.Producer.Config.html#exchange/1","title":"Lapin.Producer.Config.exchange/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.mandatory/1 .","ref":"Lapin.Producer.Config.html#mandatory/1","title":"Lapin.Producer.Config.mandatory/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.persistent/1 .","ref":"Lapin.Producer.Config.html#persistent/1","title":"Lapin.Producer.Config.persistent/1","type":"function"},{"doc":"Lapin.Producer implementation for the Publish/Subscribe RabbitMQ pattern.","ref":"Lapin.Producer.PubSub.html","title":"Lapin.Producer.PubSub","type":"module"},{"doc":"Callback implementation for Lapin.Producer.confirm/1 .","ref":"Lapin.Producer.PubSub.html#confirm/1","title":"Lapin.Producer.PubSub.confirm/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.exchange/1 .","ref":"Lapin.Producer.PubSub.html#exchange/1","title":"Lapin.Producer.PubSub.exchange/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.mandatory/1 .","ref":"Lapin.Producer.PubSub.html#mandatory/1","title":"Lapin.Producer.PubSub.mandatory/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.persistent/1 .","ref":"Lapin.Producer.PubSub.html#persistent/1","title":"Lapin.Producer.PubSub.persistent/1","type":"function"},{"doc":"Lapin.Producer implementation for the Routing RabbitMQ pattern.","ref":"Lapin.Producer.Routing.html","title":"Lapin.Producer.Routing","type":"module"},{"doc":"Callback implementation for Lapin.Producer.confirm/1 .","ref":"Lapin.Producer.Routing.html#confirm/1","title":"Lapin.Producer.Routing.confirm/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.exchange/1 .","ref":"Lapin.Producer.Routing.html#exchange/1","title":"Lapin.Producer.Routing.exchange/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.mandatory/1 .","ref":"Lapin.Producer.Routing.html#mandatory/1","title":"Lapin.Producer.Routing.mandatory/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.persistent/1 .","ref":"Lapin.Producer.Routing.html#persistent/1","title":"Lapin.Producer.Routing.persistent/1","type":"function"},{"doc":"Lapin.Producer implementation for the Topics RabbitMQ pattern.","ref":"Lapin.Producer.Topic.html","title":"Lapin.Producer.Topic","type":"module"},{"doc":"Callback implementation for Lapin.Producer.confirm/1 .","ref":"Lapin.Producer.Topic.html#confirm/1","title":"Lapin.Producer.Topic.confirm/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.exchange/1 .","ref":"Lapin.Producer.Topic.html#exchange/1","title":"Lapin.Producer.Topic.exchange/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.mandatory/1 .","ref":"Lapin.Producer.Topic.html#mandatory/1","title":"Lapin.Producer.Topic.mandatory/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.persistent/1 .","ref":"Lapin.Producer.Topic.html#persistent/1","title":"Lapin.Producer.Topic.persistent/1","type":"function"},{"doc":"Lapin.Producer implementation for the Work Queues RabbitMQ pattern.","ref":"Lapin.Producer.WorkQueue.html","title":"Lapin.Producer.WorkQueue","type":"module"},{"doc":"Callback implementation for Lapin.Producer.confirm/1 .","ref":"Lapin.Producer.WorkQueue.html#confirm/1","title":"Lapin.Producer.WorkQueue.confirm/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.exchange/1 .","ref":"Lapin.Producer.WorkQueue.html#exchange/1","title":"Lapin.Producer.WorkQueue.exchange/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.mandatory/1 .","ref":"Lapin.Producer.WorkQueue.html#mandatory/1","title":"Lapin.Producer.WorkQueue.mandatory/1","type":"function"},{"doc":"Callback implementation for Lapin.Producer.persistent/1 .","ref":"Lapin.Producer.WorkQueue.html#persistent/1","title":"Lapin.Producer.WorkQueue.persistent/1","type":"function"},{"doc":"Lapin Queue","ref":"Lapin.Queue.html","title":"Lapin.Queue","type":"module"},{"doc":"","ref":"Lapin.Queue.html#bind/2","title":"Lapin.Queue.bind/2","type":"function"},{"doc":"","ref":"Lapin.Queue.html#declare/2","title":"Lapin.Queue.declare/2","type":"function"},{"doc":"","ref":"Lapin.Queue.html#new/2","title":"Lapin.Queue.new/2","type":"function"},{"doc":"Queue","ref":"Lapin.Queue.html#t:t/0","title":"Lapin.Queue.t/0","type":"type"},{"doc":"Lapin, a RabbitMQ client for Elixir","ref":"main.html","title":"Lapin, a RabbitMQ client for Elixir","type":"extras"},{"doc":"Lapin is a RabbitMQ client for Elixir which abstracts away a lot of the complexities of interacting with an AMQP broker. While some advanced features, like publisher confirms , are tied to RabbitMQ implementation specific extensions, Lapin should play well with other broker implementations conforming to the AMQP 0.9.1 specification.","ref":"main.html#description","title":"Lapin, a RabbitMQ client for Elixir - Description","type":"extras"},{"doc":"Just add Lapin as a dependency to your mix.exs : defp deps ( ) do [ { :lapin , &quot;~&gt; 1.0.0&quot; } ] end And add the Lapin.Supervisor under your application supervision tree: children = [ Lapin.Supervisor ... ]","ref":"main.html#installation","title":"Lapin, a RabbitMQ client for Elixir - Installation","type":"extras"},{"doc":"If you are impatient to try Lapin out, just tweak this basic configuration example: config :lapin , :connections , [ [ module : ExampleApp.Worker , consumers : [ [ queue : &quot;some_queue&quot; ] ] , producers : [ [ exchange : &quot;some_exchange&quot; ] ] ] ] and define your worker module as follows: defmodule ExampleApp.Worker do use Lapin.Connection end To test your setup make sure RabbitMQ is running and configured correctly, then run your application with iex -S mix and publish a message: ... iex(1)&gt; ExampleApp.Worker . publish ( &quot;some_exchange&quot; , &quot;routing_key&quot; , &quot;payload&quot; ) Published % Lapin.Message { meta : %{ content_type : nil , mandatory : true , persistent : true } , payload : &quot;msg&quot; } on % Lapin.Producer { channel : % AMQP.Channel { conn : % AMQP.Connection { pid : # PID &lt; 0 . 305 . 0 &gt; } , pid : # PID &lt; 0 . 320 . 0 &gt; } , config : [ pattern : Lapin.Producer.WorkQueue , exchange : &quot;some_exchange&quot; ] , exchange : &quot;some_exchange&quot; , pattern : Lapin.Producer.WorkQueue } :ok [ debug ] Consuming message 1 [ debug ] Consumed message 1 successfully , ACK sent ... Read on to learn how easy it is to tweak this basic configuration.","ref":"main.html#quick-start","title":"Lapin, a RabbitMQ client for Elixir - Quick Start","type":"extras"},{"doc":"You can configure multiple connections. Each connection is backed by a worker which can implement a few callbacks to publish/consume messages and handle other type of events from the broker. Each connection can have one or more producers/consumers. The default implementation of all callbacks simply returns :ok . You need to configure a worker module for all connections. To implement a worker module, define a module and use the Lapin.Connection behaviour, then add it under the module key in your configuration. For details on implementing Lapin worker modules check out the Lapin.Connection behaviour documentation. At a minimum, you need to configure a module for each connection, an exchange for each producers and a queue for each consumer. You can find the complete list of connection configuration settings in the in Lapin.Connection config type specification. Advanced consumer/producer behaviour can be configured in two ways. One-shot, static consumer/producer configuration If you are fine with one shot configuration of your comsumers/producers, you can specify any settings from the Lapin.Consumer / Lapin.Producer config type specification directly in your the corresponding configuration keyword list. This is quick and easy way to start. lib/example_app/some_worker.ex : defmodule ExampleApp.Worker do use Lapin.Connection end config/config.exs : config :lapin , :connections , [ [ module : ExampleApp.Worker , consumers : [ [ queue : &quot;some_queue&quot; , ack : true ] ] , producers : [ [ exchange : &quot;some_exchange&quot; , mandatory : true ] ] ] ] Reusable, static or dynamic consumer/producer configuration If you need to configure a lot of consumers/producers in the same way, you can use a Lapin.Consumer / Lapin.Producer to define reusable configurations. A pattern is simply a collection of behaviour callbacks bundled in a module, which you can then reuse in any consumer/producer configuration when you need the same kind of interaction pattern. To do this, you need to define your producer/consumer module by use Lapin.Consumer or use Lapin.Producer and specify it in your configuration under the pattern key. In fact Lapin bundles a few consumer/producer implementations for the RabbitMQ tutorials patterns . lib/example_app/some_pattern.ex : defmodule ExampleApp.Consumer do use Lapin.Consumer def ack ( _channel ) , do : true def consumer_prefetch ( _channel ) , do : 1 end defmodule ExampleApp.Producer do use Lapin.Producer def confirm ( _channel ) , do : false def mandatory ( _channel ) , do : true def persistent ( _channel ) , do : true end config/config.exs : config :lapin , :connections , [ [ module : ExampleApp.Worker consumers : [ [ queue : &quot;some_queue&quot; , pattern : ExampleApp.Consumer ] ] , producers : [ [ exchange : &quot;some_exchange&quot; , pattern : ExampleApp.Producer ] ] ] ] Since Lapin.Consumer and Lapin.Producer are just behaviours of overridable callback functions, they also allow you to implement any kind of dynamic runtime configuration. Actually, the one-shot static configuration explained earlier is provided by the default implementations, which read settings from the configuration and tries to provide sensible defaults. Declaring broker configuration If you want to declare exchanges and queues with the broker you can do so in the configuration. Lapin will just declare the specied exchanges, queues and bindings and report any discrepancies between the configuration and the broker state if there are any. config :lapin , :connections , [ module : ExampleApp.Worker , exchanges : [ some_exchange : [ type : :direct , options : [ durable : true ] , binds : [ some_queue : [ routing_key : &quot;some_routing_key&quot; ] ] ] ] , queues : [ some_queue : [ options : [ durable : true ] , binds : [ some_exchange : [ routing_key : &quot;some_routing_key&quot; ] ] ] ] , ... ] Exchange declarations support type ( default: :direct ), options (see AMQP.Exchange.declare/4 for allowed exchange types and options) and binds , which is a keyword list of queue names and declare arguments (see AMQP.Queue.bind/4 for allowed arguments). Queue declarations support options (see AMQP.Queue.declare/3 for allowed options) and binds , which is a keyword list of exchange names and declare arguments (see AMQP.Exchange.bind/4 for allowed arguments).","ref":"main.html#configuration","title":"Lapin, a RabbitMQ client for Elixir - Configuration","type":"extras"},{"doc":"Consuming messages Once you have completed your configuration, connections will be automatically established and channels will start receiving messages published on the queues they are consuming. You can handle received messages by overriding the Lapin.Connection handle_deliver/2 callback. The default implementation simply logs messages and returns :ok . defmodule ExampleApp.Worker do use Lapin.Connection def handle_deliver ( channel , message ) do Logger . debug fn -&gt; &quot;received \#{ inspect message } on \#{ inspect channel } &quot; end :ok end end Since messages for all consumers on the same connection are received by the same worker module, to dispatch messages to different handling logic you can pattern match on the Channel.config map, which contains message routing information. defmodule ExampleApp.Worker do use Lapin.Connection def handle_deliver ( % Channel { exchange : &quot;a&quot; , queue : &quot;b&quot; } = channel , message ) do Logger . debug fn -&gt; &quot;received \#{ inspect message } on \#{ inspect channel } &quot; end :ok end def handle_deliver ( % Channel { exchange : &quot;c&quot; , queue : &quot;d&quot; } = channel , message ) do Logger . debug fn -&gt; &quot;received \#{ inspect message } on \#{ inspect channel } &quot; end :ok end end Messages are considered to be successfully consumed if the Lapin.Connection handle_deliver/2 callback returns :ok . See the callback documentation for a complete list of possible values you can return to signal message acknowledgement and rejection to the broker. Publishing messages To publish messages you can use the publish function injected in your worker module by use Lapin.Connection , or directly call Lapin.Connection.publish/5 by passing your worker module as the connection argument. config/config.exs : config :lapin , :connections , [ [ module : ExampleApp.Worker , producers : [ [ exchange : &quot;some_exchange&quot; ] ] ] ] Using the worker module implementation: :ok = ExampleApp.Worker . publish ( &quot;some_exchange&quot; , &quot;routing_key&quot; , &quot;payload&quot; , [ ] ) Via Lapin.Connection by passing the worker module as the connection: :ok = Lapin.Connection . publish ( ExampleApp.Worker , &quot;some_exchange&quot; , &quot;routing_key&quot; , &quot;payload&quot; , [ ] ) If you are starting a Lapin.Connection manually, you can also pass the connection pid: { :ok , pid } = Lapin.Connection . start_link ( [ module : ExampleApp.Worker , producers : [ [ exchange : &quot;some_exchange&quot; ] ] ] ) :ok = Lapin.Connection . publish ( pid , &quot;some_exchange&quot; , &quot;routing_key&quot; , % Lapin.Message { } , [ ] ) Message payload encoding Message payload is assumed to be binary by default, and is sent and received unaltered by your code. However, Lapin can handle message encoding and decoding for you. Automatic encoding of the message payload is done by passing a data type other than binary as the payload argument to the publish methods. And by providing an implementation of the Lapin.Message.Payload protocol for your data type. When consuming, the Lapin.Connection payload_for/2 callback of the worker module allows you to return an instance of the data type you want to perform message decoding into. Again, an implementation of the Lapin.Message.Payload protocol is required for your custom payload data type (e.g. a struct). The Lapin.Message.Payload protocol documentation explains how to implement the required functions, and provides an example JSON to struct implementation.","ref":"main.html#usage","title":"Lapin, a RabbitMQ client for Elixir - Usage","type":"extras"}]